#!/bin/sh

root="/root/armagetronad"
source=$root"/0.2.9-armagetronad-sty+ct+ap"

if [ -z "$1" ] || [ -z "$2" ]; then
    echo -e "Usage:\t$0 <user> <server>"
    exit 1
fi

usr=$1
srv=$2

saveto=$root"/users/"$usr"/servers/"$srv

cd $source

echo -e "Bootstrappng..."
./bootstrap.sh > /dev/null
if [ $? -ne 0 ]; then
    echo -e "Error while bootstrapping."
    exit 1
fi

echo -e "Configuring..."
CXXFLAGS="-pipe -march=native" ./configure --enable-dedicated --enable-armathentication --disable-automakedefaults --disable-sysinstall --disable-useradd --disable-etc --disable-desktop --disable-initscripts --disable-uninstall --disable-games --prefix=$saveto > /dev/null
if [ $? -ne 0 ]; then
    echo -e "Error while configuring."
    exit 1
fi

echo -e "Compiling..."
make -j3 > /dev/null
if [ $? -ne 0 ]; then
    echo -e "Error while compiling."
    exit 1
fi

echo -e "Installing..."
make install > /dev/null
if [ $? -ne 0 ]; then
    echo -e "Error while installing."
    exit 1
fi

echo -e "Setting up files..."
cp -nR $root"/manage/config"/* $saveto"/etc/armagetronad-dedicated/"
cp -nR $root"/manage/scripts" $saveto"/"

echo -e "Done!"