<?php
##################################################################
######           ARMAGETRON ADVANCED WEB INTERFACE          ######
##################################################################
######  Script by: LOVER$BOY                                ######
######  Version: 1.0                                        ######
######  Description: Please leave this header. Thanks!      ######
######  Contact: zodiacsohma1@gmail.com                     ######
##################################################################

class Command
{
    var $name  = "";
    var $value = "";
    var $help  = "";
    
    static $commands = array();
    
    function __construct($name, $value = "", $help = "")
    {
        $this->name  = $name;
        $this->value = $value;
        $this->help  = $help;
        
        self::$commands[] = $this;
    }
    
    static function checkCommand($command)
    {
        if (count(self::$commands) > 0)
        {
            foreach (self::$commands as $setting)
            {
                if ($setting instanceof Command)
                {
                    if (Filter($setting->name) == Filter($command))
                        return true;
                }
            }
        }
        return false;
    }
    
    static function init()
    {
        global $COMMON;
        
        $result = $COMMON->sql->query('SELECT * FROM `commands`');
        if ($result)
        {
            if ($result->num_rows() > 0)
            {
                while ($row = $result->fetch_assoc())
                {
                    new Command($row['command_name'], $row['default_value'], $row['command_help']);
                }
            }
        }
        else
        {
            errorMessage($COMMON->sql->error());
        }
    }
}

function sendCommand($command, $value)
{
    global $COMMON;
    if ($COMMON->ssh->connected())
    {
        $line = $COMMON->echo_exec." \"".$command." ".$value."\" >> ".$COMMON->path_server_root."/command.txt";
        if ($stream = $COMMON->ssh->exec($line))
        {
            stream_set_blocking($stream, true);
            
            $message = str_replace("\n", "<br />", htmlentities(stream_get_contents($stream)));
            if (Filter($message) != "")
                statusMessage($message);
            
            return true;
        }
    }
    
    return false;
}

function showCommands()
{
    global $COMMON;
    
    loadHeaders();
    ?>
        <div style="background: #000000; text-align: left; font-size: 14px; color: #f9f9f9; overflow: visible; height: auto;">
            <table style="border: 1px solid;" border="1">
    <?php
    foreach (Command::$commands as $cmd)
    {
        ?>
                <tr>
                    <td  style="padding: 5px; border-bottom: 1px solid #880000; vertical-align: top;">
                        <span style="color: #ffff7f;"><?php echo $cmd->name; ?></span>
                    </td>
                    <td  style="padding: 5px; border-bottom: 1px solid #880000; vertical-align: top;">
                        <span style="color: #ff00ff;"><?php echo htmlentities($cmd->value); ?></span>
                    </td>
                    <td  style="padding: 5px; border-bottom: 1px solid #880000; vertical-align: top;">
                        <span style="color: #5599cc;"><?php echo $cmd->help; ?></span><br />
                    </td>
                </tr>
        <?php
    }
    ?>
            </table>
        </div>
    <?php
}

function clearConsoleLog()
{
    global $COMMON;
    
    if ($COMMON->ssh->connected())
    {
        $line = $COMMON->null_exec." > ".$COMMON->path_server_root."/console.txt";
        if ($stream = $COMMON->ssh->exec($line))
        {
            return true;
        }
    }
    
    return false;
}

function clearInputLog()
{
    global $COMMON;
    
    if ($COMMON->ssh->connected())
    {
        $line = $COMMON->null_exec." > ".$COMMON->path_server_root."/command.txt";
        if ($stream = $COMMON->ssh->exec($line))
        {
            return true;
        }
    }
    
    return false;
}
?>