<?php
##################################################################
######           ARMAGETRON ADVANCED WEB INTERFACE          ######
##################################################################
######  Script by: LOVER$BOY                                ######
######  Version: 1.0                                        ######
######  Description: Please leave this header. Thanks!      ######
######  Contact: zodiacsohma1@gmail.com                     ######
##################################################################

class Object
{
    var $id = 0;
    var $name = '';
    var $hash = '';
    
    function __construct($id, $name, $hash)
    {
        $this->id   = $id;
        $this->name = $name;
        $this->hash = $hash;
    }
}

class User extends Object
{
    var $session_id = '';
    var $servers    = 0;
    
    function __construct($id, $name, $hash, $session_id)
    {
        parent::__construct($id, $name, $hash);
        
        $this->session_id = $session_id;
    }
};

class Server extends Object
{
    var $owner = 0;
    var $online = false;
    
    var $console_log = '';
    var $input_log   = '';
    
    function __construct($id, $name, $hash, $owner)
    {
        parent::__construct($id, $name, $hash);
        
        $this->owner = $owner;
    }
};

class Data
{
    var $usr = null;   //  the users table data
    var $srv = null;   //  the servers table data
};

class StatusMsg
{
    private $message;
    private $result = false;
    
    function __construct($msg, $status = false)
    {
        $this->message = $msg."<br />\n";
        $this->result  = $status;
    }
    
    function __toString()
    {
        return $this->message;
    }
    
    function Status()
    {
        return $this->result;
    }
};

class Common
{
    var $url  = '';   //  The url to the server (VPS)
    var $data = null; //  The user data
    var $area = '';   //  The current area of the website user is viewing
    var $ssh  = null; //  The ssh class data
    var $sql  = null; //  The sql identifier
    
    //  Stores all messages to display when website headers load
    var $messages = array();
    
    //  Stores all status messages to display at the status screen
    var $stat_msgs = array();
    
    //  Whitepages (to allow access without logging in)
    var $whitepages = array();
    
    //  Browse blackpages and allowed extensions of files
    var $browse_blackpages = array();
    var $browse_extensions = array();
    var $browse_ext_images = array();
    
    var $root               = '';   //  Data location where the main script is located
    var $local_server_path  = '';   //  Data location to where server files are stored locally
    var $server_manager     = '';   //  Scripts location of managing multiple servers
    
    //  Data location where server is installed
    var $path_server_loc = '';
    
    //  Root directory of which server data files/folders are stored
    var $path_server_root = '';
    
    //  Var directory where log files are written/stored at
    var $path_server_var = '';
    
    //  Input file used to send commands to server/client
    var $path_server_input = '';
    
    //  Script file which governs the management of the server: start/stop
    var $path_server_script = '';
    
    var $php_exec  = 'php';         //!< Command used to execute php scripts
    var $bash_exec = 'bash';        //!< Command used to execute shell scripts
    var $echo_exec = 'echo';        //!< Command used to output the execution: echo ...
    var $null_exec = '/dev/null';   //!< Command used to output null
};
?>