<?php
##################################################################
######           ARMAGETRON ADVANCED WEB INTERFACE          ######
##################################################################
######  Script by: LOVER$BOY                                ######
######  Version: 1.0                                        ######
######  Description: Please leave this header. Thanks!      ######
######  Contact: zodiacsohma1@gmail.com                     ######
##################################################################

function startServer()
{
    global $COMMON;
    
    if ($COMMON->ssh->connected())
    {
        if (!$COMMON->data->srv->online)
        {
            $line = $COMMON->path_server_script." start ".$COMMON->data->usr->name." ".$COMMON->data->srv->name;
            if ($stream = $COMMON->ssh->exec($line))
            {
                stream_set_blocking($stream, true);
                
                //  retrieving the message 
                $message = str_replace("\n", "<br />", trim(htmlentities(stream_get_contents($stream))));
                if (Filter($message) != "")
                    statusMessage($message, true);
                
                return true;
            }
        }
        else
        {
            $message = "Server \"".$COMMON->data->srv->name."\"is already online.";
            statusMessage($message);
            
            return true;
        }
    }
    
    $message = "Couldn't start \"".$COMMON->data->srv->name."\" server...";
    statusMessage($message);
    
    return false;
}

function stopServer()
{
    global $COMMON;
    
    if ($COMMON->ssh->connected())
    {
        if ($COMMON->data->srv->online)
        {
            $line = $COMMON->path_server_script." stop ".$COMMON->data->usr->name." ".$COMMON->data->srv->name;
            if ($stream = $COMMON->ssh->exec($line))
            {
                stream_set_blocking($stream, true);
                
                //  retrieving the message 
                $message = str_replace("\n", "<br />", trim(htmlentities(stream_get_contents($stream))));
                if (Filter($message) != "")
                    statusMessage($message, true);
                
                return true;
            }
        }
        else
        {
            $message = "Server \"".$COMMON->data->srv->name."\"is already offline.";
            statusMessage($message);
            
            return true;
        }
    }
    
    $message = "Couldn't stop \"".$COMMON->data->srv->name."\" server...";
    statusMessage($message);
    
    return false;
}

function updateServerData($server_data)
{
    global $COMMON;
    
    if ($server_data)
    {
        if (isset($_SESSION['server_name']))
        {
            if (hash("md4", Filter($_SESSION['server_name'])) === $server_data['server_hash'])
            {
                $COMMON->data->srv = new Server($server_data['server_id'], $server_data['server_name'], $server_data['server_hash'], $server_data['owner_id']);
                
                $_SESSION['server_id']   = $COMMON->data->srv->id;
                $_SESSION['server_name'] = $COMMON->data->srv->name;
                
                fillServerNames();
                
                return true;
            }
            else
            {
                errorMessage("Servers owned do not match.");
            }
        }
        else
        {
            $COMMON->data->srv = new Server($server_data['server_id'], $server_data['server_name'], $server_data['server_hash'], $server_data['owner_id']);
            
            $_SESSION['server_id']   = $COMMON->data->srv->id;
            $_SESSION['server_name'] = $COMMON->data->srv->name;
            
            fillServerNames();
            
            return true;
        }
    }
    
    return false;
}

function serverManager()
{
    global $COMMON;
    
    if (isset($_POST['srv_mag_select']))
    {
        $s_result = $COMMON->sql->query('SELECT * FROM `servers` WHERE `server_id`="'.@$_POST['srv_mag_server'].'" AND `owner_id`="'.$COMMON->data->usr->id.'"');
        if ($s_result)
        {
            $server_data = $s_result->fetch_assoc();
            updateServerData($server_data);
        }
        else
        {
            errorMessage($COMMON->sql->error());
        }
    }
    
    loadHeaders();
    
    $s_result = $COMMON->sql->query('SELECT * FROM `servers` WHERE `owner_id`="'.$COMMON->data->usr->id.'"');
    if ($s_result)
    {
        ?>
        <form action="" method="post">
            <center>
                <table class="form_area">
                    <tr>
                        <td align="left" style="vertical-align: top;">
                            <span style="text-align: center;"><b>Server Selection</b></span>
                            <br />
        <?php
        while ($server_row = $s_result->fetch_assoc())
        {
            ?>
            <input type="radio" name="srv_mag_server" value="<?php echo $server_row['server_id']; ?>" <?php echo ($server_row['server_id'] == $COMMON->data->srv->id)?'checked="true"':""; ?> /><?php echo $server_row['server_name']; ?>
            <br />
            <?php
        }
        ?>
                            <input type="submit" name="srv_mag_select" value="Select" style="width: 100%; padding: 5px;" />
                        </td>
                    </tr>
                </table>
            </center>
        </form>
        <?php
    }
    else
    {
        errorMessage(mysql_error($COMMON->sql));
    }
}

function checkServer()
{
    global $COMMON;
    
    createLocalFolders();
    
    if ($COMMON->ssh->connected())
    {
        /*
        if (!file_exists($COMMON->local_server_path."/console.txt"))
            file_put_contents($COMMON->local_server_path."/console.txt", "");
        
        if (!file_exists($COMMON->local_server_path."/command.txt"))
            file_put_contents($COMMON->local_server_path."/command.txt", "");
        */
        
        //  try downloading the console file
        if (!$COMMON->ssh->download_file($COMMON->path_server_root."/console.txt", $COMMON->local_server_path."/console.txt"))
            errorMessage("Download of the console file has failed for unknown reasons.", false, true);
        
        //  try downloading the input file
        if (!$COMMON->ssh->download_file($COMMON->path_server_root."/command.txt", $COMMON->local_server_path."/command.txt"))
            errorMessage("Download of the input file has failed for unknown reasons.", false, true);
        
        $COMMON->data->srv->console_log = htmlentities(@file_get_contents($COMMON->local_server_path."/console.txt"));
        $COMMON->data->srv->input_log   = htmlentities(@file_get_contents($COMMON->local_server_path."/command.txt"));
        
        if (Filter($COMMON->data->srv->console_log) == "")
            $COMMON->data->srv->console_log = "No console to display...";
        
        if (Filter($COMMON->data->srv->input_log) == "")
            $COMMON->data->srv->input_log   = "No input commands to display...";
    }
    else
    {
        $COMMON->data->srv->console_log = "No console to display...";
        $COMMON->data->srv->input_log   = "No input commands to display...";
    }
}

function fillServerNames()
{
    global $COMMON;
    
    $COMMON->local_server_path  = $COMMON->root."/users/".$COMMON->data->usr->name."/servers/".$COMMON->data->srv->name;
    $COMMON->path_server_root   = $COMMON->path_server_loc."/users/".$COMMON->data->usr->name."/servers/".$COMMON->data->srv->name;
}

function check_sever_status()
{
    global $COMMON;
    
    if ($COMMON->ssh->connected())
    {
        $line = $COMMON->server_manager."server_online.sh ".$COMMON->data->usr->name." ".$COMMON->data->srv->name;
        if ($stream = $COMMON->ssh->exec($line))
        {
            stream_set_blocking($stream, true);
            $content = stream_get_contents($stream);
            
            switch (Filter($content))
            {
                case "true":
                    $COMMON->data->srv->online = true;
                    break;
                
                default:
                    $COMMON->data->srv->online = false;
                    break;
            }
        }
    }
    
    return false;
}
?>