<?php
##################################################################
######           ARMAGETRON ADVANCED WEB INTERFACE          ######
##################################################################
######  Script by: LOVER$BOY                                ######
######  Version: 1.0                                        ######
######  Description: Please leave this header. Thanks!      ######
######  Contact: zodiacsohma1@gmail.com                     ######
##################################################################

class SSH
{
    var $connection = null;
    var $sftp       = null;
    
    var $host = '';
    var $port = 22;
    
    var $username = '';
    
    var $connected = false;
    
    function __construct($host, $port = 22)
    {
        if (function_exists('ssh2_connect'))
        {
            $this->host = $host;
            $this->port = $port;
            
            $this->connection = ssh2_connect($this->host, $this->port);
        }
    }
    
    function connected()
    {
        return $this->connected;
    }
    
    function login($username, $password)
    {
        if ($this->connection)
        {
            $this->username  = $username;
            $this->connected = ssh2_auth_password($this->connection, $this->username, $password);
            $this->sftp      = ssh2_sftp($this->connection);
        }
        
        return $this->connected;
    }
    
    function exec($params)
    {
        if ($this->connection)
        {
            return ssh2_exec($this->connection, $params);
        }
        
        return null;
    }
    
    //  download file from $remote -> $local
    //  Return flag if true for downloaded or false for failure
    function download_file($remote, $local)
    {
        if ($this->connection)
        {
            return ssh2_scp_recv($this->connection, $remote, $local);
        }
        
        return false;
    }
    
    //  upload file from $local -> $remote
    //  Return flag if true for uploaded or false for failure
    function upload_file($local, $remote)
    {
        if ($this->connection)
        {
            return ssh2_scp_send($this->connection, $local, $remote, 0644);
        }
        
        return false;
    }
};
?>